Index: /trunk/zoo-project/zoo-kernel/service_json.h
===================================================================
--- /trunk/zoo-project/zoo-kernel/service_json.h	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/service_json.h	(revision 949)
@@ -28,4 +28,5 @@
 #pragma once
 
+#include "response_print.h"
 #include <stdio.h>
 #include <ctype.h>
@@ -36,7 +37,24 @@
 extern "C" {
 #endif
+  /**
+   * Name and corresponding attributes depending on the WPS version
+   */
+  static const char* jcapabilities[4]={
+    "jobControlOptions","sync-execute async-execute dismiss",
+    "outputTransmission","value reference"
+  };
+
   json_object* mapToJson(map*);
   json_object* mapsToJson(maps*);
   json_object* serviceToJson(service*);
+  void printGetCapabilitiesForProcessJ(registry*, maps*,void*,void*,service*);
+  void printExceptionReportResponseJ(maps*,map*);
+  void parseJRequest(maps*,service* s,json_object*,maps**,maps**);
+  json_object*  printJResult(maps*,service*,maps*,int);
+  json_object* printJobList(maps*);
+  int createStatusFile(maps*,int);
+  int json_getStatusFile(maps*);
+  void produceApi(maps*,json_object*);
+  //void printIOTypeJ(maps*, const char*, elements*,json_object*,service*);
 #ifdef __cplusplus
 }
Index: /trunk/zoo-project/zoo-kernel/zoo_loader.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/zoo_loader.c	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/zoo_loader.c	(revision 949)
@@ -98,5 +98,28 @@
   map* tmpMap=NULL;
 
-  if(strncmp(cgiContentType,"text/xml",8)==0 || 
+  if(strncmp(cgiContentType,"application/json",16)==0 &&
+     strncasecmp(cgiRequestMethod,"post",4)==0){
+       char *buffer=new char[2];
+       char *res=NULL;
+       int r=0;
+       int len=0;
+       while((r=fread(buffer,sizeof(char),1,cgiIn))>0){
+	 fprintf(stderr,"%s",buffer);
+	 buffer[1]=0;
+	 if(res==NULL){
+	   res=(char*)malloc(2*sizeof(char));
+	   sprintf(res,"%s",buffer);
+	 }
+	 else{
+	   res=(char*)realloc(res,(len+2)*sizeof(char));
+	   memcpy(res + len, buffer, sizeof(char));
+	   res[len+1]=0;
+	 }
+	 len+=1;
+       }
+       delete[] buffer;
+       tmpMap=createMap("jrequest",res);
+       free(res);
+  }else if(strncmp(cgiContentType,"text/xml",8)==0 ||
      strncasecmp(cgiRequestMethod,"post",4)==0){
     if(cgiContentLength==0){
@@ -123,5 +146,5 @@
        if(res!=NULL)
 	 free(res);
-    }else{		
+    }else{  
       char *buffer=new char[cgiContentLength+1];
       if(fread(buffer,sizeof(char),cgiContentLength,cgiIn)>0){
@@ -363,7 +386,12 @@
       xmlCleanupParser();
     }else{
-      freeMap(&tmpMap);
-      free(tmpMap);
-      tmpMap=createMap("not_valid","true");
+      if(tmpMap!=NULL){	
+	if(getMap(tmpMap,"jrequest")==NULL){
+	  freeMap(&tmpMap);
+	  free(tmpMap);
+	  tmpMap=createMap("not_valid","true");
+	}
+      }else
+	tmpMap=createMap("not_valid","true");
     }
 
@@ -408,5 +436,5 @@
   if(strQuery!=NULL)
     free(strQuery);
-  
+
   runRequest(&tmpMap);
 
Index: /trunk/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 949)
@@ -70,5 +70,5 @@
 #include "request_parser.h"
 #include "sqlapi.h"
-#ifdef WIN32
+#ifdef USE_JSON
 #include "caching.h"
 #endif
@@ -107,6 +107,10 @@
 
 #ifdef USE_CALLBACK
+#include "service_callback.h"
+#endif
+
+#ifdef USE_JSON
 #include "service_json.h"
-#include "service_callback.h"
+#include "json_tokener.h"
 #endif
 
@@ -258,10 +262,14 @@
  */
 int
-recursReaddirF ( maps * m, registry *r, xmlDocPtr doc, xmlNodePtr n, char *conf_dir, 
-		 char *prefix, int saved_stdout, int level, 
-		 void (func) (registry *, maps *, xmlDocPtr, xmlNodePtr, service *) )
+recursReaddirF ( maps * m, registry *r, void* doc1, void* n1, char *conf_dir,
+		 //( maps * m, registry *r, xmlDocPtr doc, xmlNodePtr n, char *conf_dir,
+		 char *prefix, int saved_stdout, int level,
+		 void (func) (registry *, maps *, void*, void*, service *) )
+		 //void (func) (registry *, maps *, xmlDocPtr, xmlNodePtr, service *) )
 {
   struct dirent *dp;
   int scount = 0;
+  xmlDocPtr doc=(xmlDocPtr) doc1;
+  xmlNodePtr n=(xmlNodePtr) n1;
 
   if (conf_dir == NULL)
@@ -385,4 +393,601 @@
 
 /**
+ * When th zcfg file is not found, print error message and cleanup memory
+ * @param zooRegistry the populated registry
+ * @param m the maps pointer to the content of main.cfg file
+ * @param zcfg the zcfg file name
+ * @param code the string determining the nature of the error
+ * @param locator the string determining which parameter the error refer to
+ * @param orig the service name
+ * @param corig the current service name (in case multiple services was parsed)
+ * @param funcError the function used to print the error back
+ */
+void exitAndCleanUp(registry* zooRegistry, maps* m,
+		    const char* zcfg,const char* code,const char* locator,
+		    char* orig,char* corig,
+		    void (funcError) (maps*, map*)){
+  map *tmp00 = getMapFromMaps (m, "lenv", "message");
+  char tmp01[1024];
+  if (tmp00 != NULL)
+    sprintf (tmp01,
+	     _("Unable to parse the ZCFG file: %s (%s)"),
+	     zcfg, tmp00->value);
+  else
+    sprintf (tmp01,
+	     _("Unable to parse the ZCFG file: %s."),
+	     zcfg);
+  map* errormap = createMap("text", tmp01);
+  addToMap(errormap,"code", code);
+  addToMap(errormap,"locator", locator);
+  funcError(m,errormap);
+  freeMaps (&m);
+  free (m);
+  if(zooRegistry!=NULL){
+    freeRegistry(&zooRegistry);
+    free(zooRegistry);
+  }
+  free (orig);
+  if (corig != NULL)
+    free (corig);
+  //xmlFreeDoc (doc);
+  xmlCleanupParser ();
+  zooXmlCleanupNs ();
+  freeMap(&errormap);
+  free(errormap);
+}
+
+
+/**
+ * Search services from various possible sources 
+ *
+ * @param zopRegistry the populated registry
+ * @param m the maps pointer to the content of main.cfg file
+ * @param r_inputs the service(s) name(s)
+ * @param func the function used to print the result back
+ * @param doc the xml document or NULL (for json)
+ * @param n the xmlNode of JSON object pointer to the current element
+ * @param conf_dir the directory where the main.cfg has been found
+ * @param request_inputs the map pointer to the request KVP if any
+ * @param funcError the function used to print the error back
+ * @return 0 in case of success, 1 otherwise
+ */
+int fetchServicesForDescription(registry* zooRegistry, maps* m, char* r_inputs,
+				void (func) (registry *, maps *, void*, void*, service *),
+				void* doc, void* n, char* conf_dir, map* request_inputs,
+				void (funcError) (maps*, map*) ){
+  char *orig = zStrdup (r_inputs);
+  service* s1=NULL;
+  int saved_stdout = zDup (fileno (stdout));
+  int t;
+  int scount = 0;
+  struct dirent *dp;
+
+  zDup2 (fileno (stderr), fileno (stdout));  
+  if (strcasecmp ("all", orig) == 0)
+    {
+      maps* imports = getMaps(m, IMPORTSERVICE); 
+      if (imports != NULL) {       
+	map* zcfg = imports->content;
+            
+	while (zcfg != NULL) {
+	  if (zcfg->value != NULL) {
+	    service* svc = (service*) malloc(SERVICE_SIZE);
+	    if (svc == NULL || readServiceFile(m, zcfg->value, &svc, zcfg->name) < 0) {
+	      // pass over silently
+	      zcfg = zcfg->next;
+	      continue;
+	    }
+	    inheritance(zooRegistry, &svc);
+#ifdef USE_HPC
+	    addNestedOutputs(&svc);
+#endif
+
+	    func(zooRegistry, m, doc, n, svc);
+	    freeService(&svc);
+	    free(svc);                             
+	  }
+	  zcfg = zcfg->next;
+	}            
+      }
+      if (int res =
+	  recursReaddirF (m, zooRegistry, doc, n, conf_dir, NULL, saved_stdout, 0,
+			  func) < 0)
+	return res;
+#ifdef META_DB
+      fetchServicesFromDb(zooRegistry,m,doc,n,func,0);
+      close_sql(m,0);
+#endif
+    }
+  else
+    {
+      DIR *dirp = opendir (conf_dir);
+      char *saveptr;
+      char *tmps = strtok_r (orig, ",", &saveptr);
+
+      char buff[256];
+      char buff1[1024];
+      while (tmps != NULL)
+	{
+	  int hasVal = -1;
+	  char *corig = zStrdup (tmps);
+	  map* import = getMapFromMaps (m, IMPORTSERVICE, corig);   
+	  if (import != NULL && import->value != NULL) 
+	    {
+#ifdef META_DB			
+	      service* s2=extractServiceFromDb(m,import->name,0);
+	      if(s2==NULL){
+#endif
+		s1 = createService();
+		t = readServiceFile (m, import->value, &s1, import->name);
+
+		if (t < 0) // failure reading zcfg
+		  {
+		    zDup2 (saved_stdout, fileno (stdout));
+		    exitAndCleanUp(zooRegistry, m,
+				   tmps,"InvalidParameterValue","identifier",
+				   orig,corig,
+				   funcError);
+                    return 1;
+		  }
+#ifdef DEBUG
+		dumpService (s1);
+#endif
+		inheritance(zooRegistry,&s1);
+#ifdef USE_HPC
+		addNestedOutputs(&s1);
+#endif
+		func (zooRegistry, m, doc, n, s1);
+		freeService (&s1);
+		free (s1);
+		s1 = NULL;
+		scount++;
+		hasVal = 1;                
+#ifdef META_DB
+	      }
+#endif
+	    }
+	  else if (strstr (corig, ".") != NULL)
+	    {
+	      parseIdentifier (m, conf_dir, corig, buff1);
+	      map *tmpMap = getMapFromMaps (m, "lenv", "metapath");
+	      if (tmpMap != NULL)
+		addToMap (request_inputs, "metapath", tmpMap->value);
+	      map *tmpMapI = getMapFromMaps (m, "lenv", "Identifier");
+	      /**
+	       * No support for dot in service name stored in metadb!?
+	       #ifdef META_DB
+	       service* s2=extractServiceFromDb(m,tmpMapI->value,0);
+	       if(s2==NULL){
+	       #endif
+	      */
+	      s1 = createService();
+	      t = readServiceFile (m, buff1, &s1, tmpMapI->value);
+	      if (t < 0)
+		{
+		  zDup2 (saved_stdout, fileno (stdout));
+		  exitAndCleanUp(zooRegistry, m,
+				 tmps,"InvalidParameterValue","identifier",
+				 orig,corig,
+				 funcError);
+		  return 1;
+		}
+#ifdef DEBUG
+	      dumpService (s1);
+#endif
+	      inheritance(zooRegistry,&s1);
+#ifdef USE_HPC
+	      addNestedOutputs(&s1);
+#endif
+	      func (zooRegistry, m, doc, n, s1);
+	      freeService (&s1);
+	      free (s1);
+	      s1 = NULL;
+	      scount++;
+	      hasVal = 1;
+	      setMapInMaps (m, "lenv", "level", "0");
+	    }
+	  else
+	    {
+#ifdef META_DB
+	      _init_sql(m,"metadb");
+	      //FAILED CONNECTING DB
+	      if(getMapFromMaps(m,"lenv","dbIssue")!=NULL){
+		fprintf(stderr,"ERROR CONNECTING METADB");
+	      }
+	      service* s2=extractServiceFromDb(m,corig,0);
+	      if(s2!=NULL){
+		inheritance(zooRegistry,&s2);
+#ifdef USE_HPC
+		addNestedOutputs(&s2);
+#endif
+		func (zooRegistry,m, doc, n, s2);
+		freeService (&s2);
+		free (s2);
+		s2 = NULL;
+		hasVal = 1;
+	      }else /*TOTO*/{
+#endif
+		memset (buff, 0, 256);
+		snprintf (buff, 256, "%s.zcfg", corig);
+		memset (buff1, 0, 1024);
+#ifdef DEBUG
+		printf ("\n#######%s\n########\n", buff);
+#endif
+		while ((dp = readdir (dirp)) != NULL)
+		  {
+		    if (strcasecmp (dp->d_name, buff) == 0)
+		      {
+			memset (buff1, 0, 1024);
+			snprintf (buff1, 1024, "%s/%s", conf_dir,
+				  dp->d_name);
+			s1 = createService();
+			if (s1 == NULL)
+			  {
+			    zDup2 (saved_stdout, fileno (stdout));
+			    map* errormap = createMap("text", _("Unable to allocate memory"));
+			    addToMap(errormap,"code", "InternalError");
+			    addToMap(errormap,"locator", "NULL");
+			    funcError(m,errormap);
+			    return -1;
+			  }
+#ifdef DEBUG_SERVICE_CONF
+			fprintf
+			  (stderr,"#################\n(%s) %s\n#################\n",
+			   r_inputs->value, buff1);
+#endif
+			char *tmp0 = zStrdup (dp->d_name);
+			tmp0[strlen (tmp0) - 5] = 0;
+			t = readServiceFile (m, buff1, &s1, tmp0);
+			free (tmp0);
+			if (t < 0)
+			  {
+			    zDup2 (saved_stdout, fileno (stdout));
+			    exitAndCleanUp(zooRegistry, m,
+					   buff,"InternalError","NULL",
+					   orig,corig,
+					   funcError);
+			    return 1;
+			  }
+#ifdef DEBUG
+			dumpService (s1);
+#endif
+			inheritance(zooRegistry,&s1);
+#ifdef USE_HPC
+			addNestedOutputs(&s1);
+#endif
+			func (zooRegistry,m, doc, n, s1);
+			freeService (&s1);
+			free (s1);
+			s1 = NULL;
+			scount++;
+			hasVal = 1;
+		      }
+		  }
+#ifdef META_DB
+	      }
+#endif
+	    }		      
+	  if (hasVal < 0)
+	    {
+	      zDup2 (saved_stdout, fileno (stdout));
+	      exitAndCleanUp(zooRegistry, m,
+			     buff,"InvalidParameterValue","Identifier",
+			     orig,corig,
+			     funcError);
+	      return 1;
+	    }
+	  rewinddir (dirp);
+	  tmps = strtok_r (NULL, ",", &saveptr);
+	  if (corig != NULL)
+	    free (corig);
+	}		  
+    }
+  fflush (stdout);
+  zDup2 (saved_stdout, fileno (stdout));
+  free (orig);
+  return 0;
+}
+
+/**
+ * Run every HTTP request to download inputs passed as reference
+ *
+ * @param conf the maps pointing to the main.cfg file content
+ * @param inputs the maps pointing to the inputs provided in the request
+ */
+int loadHttpRequests(maps* conf,maps* inputs){
+  // Resolve reference
+  // TODO: add erro gesture
+  int eres;
+  maps* tmpMaps=getMaps(conf,"http_requests");
+  if(tmpMaps!=NULL){
+    map* lenMap=getMap(tmpMaps->content,"length");
+    int len=0;
+    if(lenMap!=NULL){
+      len=atoi(lenMap->value);
+    }
+    HINTERNET hInternet;
+    HINTERNET res;
+    if(len>0)
+      hInternet = InternetOpen (
+#ifndef WIN32
+				(LPCTSTR)
+#endif
+				"ZOO-Project WPS Client\0",
+				INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
+    for(int j=0;j<len;j++){
+      map* tmpUrl=getMapArray(tmpMaps->content,"url",j);
+      map* tmpInput=getMapArray(tmpMaps->content,"input",j);
+      maps* currentMaps=getMaps(inputs,tmpInput->value);
+      loadRemoteFile(&conf,&currentMaps->content,&hInternet,tmpUrl->value);
+      addIntToMap(currentMaps->content,"Order",hInternet.nb);
+      addToMap(currentMaps->content,"Reference",tmpUrl->value);
+    }
+    if(len>0){
+      map* error=NULL;
+      runHttpRequests(&conf,&inputs,&hInternet,&error);
+      InternetCloseHandle(&hInternet);
+    }
+  }
+  return 0;
+}
+
+/**
+ * Initialize environment sections, load env, and populate lenv and renv.
+ *
+ * @param conf the maps pointing to the main.cfg file content
+ * @param request_inputs the map pointing to the request KVP 
+ * @param cPath a string pointing to the cwd
+ * @param request a string pointing to the request key (xrequest or jrequest)
+ */
+void initAllEnvironment(maps* conf,map* request_inputs,
+			const char* cPath,const char* request){
+  // Define each env variable in runing environment
+  maps *curs = getMaps (conf, "env");
+  if (curs != NULL) {
+    map *mapcs = curs->content;
+    while (mapcs != NULLMAP)
+      {
+#ifndef WIN32
+	setenv (mapcs->name, mapcs->value, 1);
+#ifdef DEBUG
+	fprintf (stderr, "[ZOO: setenv (%s=%s)]\n", mapcs->name,
+		 mapcs->value);
+#endif
+#else
+	if (mapcs->value[strlen (mapcs->value) - 2] == '\r')
+	  {
+#ifdef DEBUG
+	    fprintf (stderr, "[ZOO: Env var finish with \r]\n");
+#endif
+	    mapcs->value[strlen (mapcs->value) - 1] = 0;
+	  }
+#ifdef DEBUG
+	if (SetEnvironmentVariable (mapcs->name, mapcs->value) == 0)
+	  {
+	    fflush (stderr);
+	    fprintf (stderr, "setting variable... %s\n", "OK");
+	  }
+	else
+	  {
+	    fflush (stderr);
+	    fprintf (stderr, "setting variable... %s\n", "OK");
+	  }
+#else
+	SetEnvironmentVariable (mapcs->name, mapcs->value);
+#endif
+	char *toto =
+	  (char *)
+	  malloc ((strlen (mapcs->name) + strlen (mapcs->value) +
+		   2) * sizeof (char));
+	sprintf (toto, "%s=%s", mapcs->name, mapcs->value);
+	_putenv (toto);
+#ifdef DEBUG
+	fflush (stderr);
+#endif
+#endif
+
+#ifdef DEBUG
+	fprintf (stderr, "[ZOO: setenv (%s=%s)]\n", mapcs->name,
+		 mapcs->value);
+	fflush (stderr);
+#endif
+	mapcs = mapcs->next;
+      }
+  }
+
+	    
+
+  int eres = SERVICE_STARTED;
+  int cpid = zGetpid ();
+
+  // Create a map containing a copy of the request map
+  maps *_tmpMaps = createMaps("request");
+  addMapToMap(&_tmpMaps->content,request_inputs);
+  addMapsToMaps (&conf, _tmpMaps);
+  freeMaps (&_tmpMaps);
+  free (_tmpMaps);
+  /**
+   * Initialize the specific [lenv] section which contains runtime variables:
+   * 
+   *  - usid : it is an universally unique identifier  
+   *  - osid : it is an idenfitication number 
+   *  - sid : it is the process idenfitication number (OS)
+   *  - uusid : it is an universally unique identifier 
+   *  - status : value between 0 and 100 to express the  completude of 
+   * the operations of the running service 
+   *  - message : is a string where you can store error messages, in case 
+   * service is failing, or o provide details on the ongoing operation.
+   *  - cwd : the current working directory or servicePath if defined
+   *  - soap : is a boolean value, true if the request was contained in a SOAP 
+   * Envelop 
+   *  - sessid : string storing the session identifier (only when cookie is 
+   * used)
+   *  - cgiSid : only defined on Window platforms (for being able to identify 
+   * the created process)
+   *
+   */
+  _tmpMaps = createMaps("lenv");
+  char tmpBuff[100];
+  struct ztimeval tp;
+  if (zGettimeofday (&tp, NULL) == 0)
+    sprintf (tmpBuff, "%i", (cpid + ((int) tp.tv_sec + (int) tp.tv_usec)));
+  else
+    sprintf (tmpBuff, "%i", (cpid + (int) time (NULL)));
+  _tmpMaps->content = createMap ("osid", tmpBuff);
+  sprintf (tmpBuff, "%i", cpid);
+  addToMap (_tmpMaps->content, "sid", tmpBuff);
+  char* tmpUuid=get_uuid();
+  addToMap (_tmpMaps->content, "uusid", tmpUuid);
+  addToMap (_tmpMaps->content, "usid", tmpUuid);
+  free(tmpUuid);
+  addToMap (_tmpMaps->content, "status", "0");
+  map* cwdMap0=getMapFromMaps(conf,"main","servicePath");
+  if(cwdMap0!=NULL){
+    addToMap (_tmpMaps->content, "cwd", cwdMap0->value);
+    addToMap (_tmpMaps->content, "rcwd", cPath);
+  }
+  else
+    addToMap (_tmpMaps->content, "cwd", cPath);
+  addToMap (_tmpMaps->content, "message", _("No message provided"));
+  map *ltmp = getMap (request_inputs, "soap");
+  if (ltmp != NULL)
+    addToMap (_tmpMaps->content, "soap", ltmp->value);
+  else
+    addToMap (_tmpMaps->content, "soap", "false");
+
+  // Parse the session file and add it to the main maps
+  char* originalCookie=NULL;
+  if (cgiCookie != NULL && strlen (cgiCookie) > 0)
+    {
+      int hasValidCookie = -1;
+      char *tcook = originalCookie = zStrdup (cgiCookie);
+      map *testing = getMapFromMaps (conf, "main", "cookiePrefix");
+      parseCookie(&conf,originalCookie);
+      map *sessId=getMapFromMaps(conf,"cookies",
+				 (testing==NULL?"ID":testing->value));
+      if (sessId!=NULL)
+	{
+	  addToMap (_tmpMaps->content, "sessid", sessId->value);
+	  char session_file_path[1024];
+	  map *tmpPath = getMapFromMaps (conf, "main", "sessPath");
+	  if (tmpPath == NULL)
+	    tmpPath = getMapFromMaps (conf, "main", "tmpPath");
+	  char *tmp1 = strtok (tcook, ";");
+	  if (tmp1 != NULL)
+	    sprintf (session_file_path, "%s/sess_%s.cfg", tmpPath->value,
+		     sessId->value);
+	  else
+	    sprintf (session_file_path, "%s/sess_%s.cfg", tmpPath->value,
+		     sessId->value);
+	  free (tcook);
+	  maps *tmpSess = (maps *) malloc (MAPS_SIZE);
+	  tmpSess->child=NULL;
+	  struct stat file_status;
+	  int istat = stat (session_file_path, &file_status);
+	  if (istat == 0 && file_status.st_size > 0)
+	    {
+	      int saved_stdout = zDup (fileno (stdout));
+	      zDup2 (fileno (stderr), fileno (stdout));
+	      conf_read (session_file_path, tmpSess);
+	      addMapsToMaps (&conf, tmpSess);
+	      freeMaps (&tmpSess);
+	      fflush(stdout);
+	      zDup2 (saved_stdout, fileno (stdout));
+	      zClose(saved_stdout);
+	    }
+	  free (tmpSess);
+	}
+    }
+  addMapsToMaps (&conf, _tmpMaps);
+  freeMaps (&_tmpMaps);
+  free (_tmpMaps);
+  maps* bmap=NULL;
+#ifdef DEBUG
+  dumpMap (request_inputs);
+#endif
+  int ei = 1;
+  
+  _tmpMaps = createMaps("renv");
+
+#ifdef WIN32
+  LPVOID orig = GetEnvironmentStrings();
+  LPTSTR s = (LPTSTR) orig;
+  
+  while (*s != NULL) {
+    char* env = strdup(s);
+    char* delim = strchr(env,'=');
+    if (delim != NULL) {
+      char* val = delim+1;
+      *delim = '\0';		
+      if(_tmpMaps->content == NULL) {
+        _tmpMaps->content = createMap(env,val);
+      }
+      else {
+        addToMap(_tmpMaps->content,env,val);
+      }			
+    }
+    s += strlen(s)+1;
+  } 
+  FreeEnvironmentStrings((LPCH)orig);	
+#else
+  char **orig = environ;
+  char *s=*orig;
+  
+  if(orig!=NULL)
+    for (; s; ei++ ) {
+      if(strstr(s,"=")!=NULL && strlen(strstr(s,"="))>1){
+	int len=strlen(s);
+	char* tmpName=zStrdup(s);
+	char* tmpValue=strstr(s,"=")+1;
+	char* tmpName1=(char*)malloc((1+(len-(strlen(tmpValue)+1)))*sizeof(char));
+	snprintf(tmpName1,(len-strlen(tmpValue)),"%s",tmpName);
+	if(_tmpMaps->content == NULL)
+	  _tmpMaps->content = createMap (tmpName1,tmpValue);
+	else
+	  addToMap (_tmpMaps->content,tmpName1,tmpValue);
+	free(tmpName1);
+	free(tmpName);
+      }
+      s = *(orig+ei);
+    }  
+#endif
+  
+  if(_tmpMaps->content!=NULL && getMap(_tmpMaps->content,"HTTP_COOKIE")!=NULL){
+    addToMap(_tmpMaps->content,"HTTP_COOKIE1",&cgiCookie[0]);
+  }
+  addMapsToMaps (&conf, _tmpMaps);
+  freeMaps (&_tmpMaps);
+  free (_tmpMaps);
+  map* postRequest=getMap(request_inputs,request);
+  if(postRequest!=NULL)
+    setMapInMaps (conf, "renv", request, postRequest->value);
+#ifdef WIN32
+  char *cgiSidL = NULL;
+  if (getenv ("CGISID") != NULL)
+    addToMap (request_inputs, "cgiSid", getenv ("CGISID"));
+
+  char* usidp;
+  if ( (usidp = getenv("USID")) != NULL ) {
+    setMapInMaps (conf, "lenv", "usid", usidp);
+  }
+
+  map *test1 = getMap (request_inputs, "cgiSid");
+  if (test1 != NULL){
+    cgiSid = zStrdup(test1->value);
+    addToMap (request_inputs, "storeExecuteResponse", "true");
+    addToMap (request_inputs, "status", "true");
+    setMapInMaps (conf, "lenv", "osid", test1->value);
+    status = getMap (request_inputs, "status");
+  }
+  test1 = getMap (request_inputs, "usid");
+  if (test1 != NULL){
+    setMapInMaps (conf, "lenv", "usid", test1->value);
+    setMapInMaps (conf, "lenv", "uusid", test1->value);
+  }
+#endif
+  
+}
+
+/**
  * Signal handling function which simply call exit(0).
  *
@@ -444,4 +1049,56 @@
   exit (0);
 }
+
+#ifdef USE_JSON
+  /**
+   * Signal handling function which create an ExceptionReport node containing the
+   * information message corresponding to the signal number.
+   *
+   * @param sig the signal number
+   */
+void json_sig_handler (int sig){
+  char tmp[100];
+  const char *ssig;
+  switch (sig)
+    {
+    case SIGSEGV:
+      ssig = "SIGSEGV";
+      break;
+    case SIGTERM:
+      ssig = "SIGTERM";
+      break;
+    case SIGINT:
+      ssig = "SIGINT";
+      break;
+    case SIGILL:
+      ssig = "SIGILL";
+      break;
+    case SIGFPE:
+      ssig = "SIGFPE";
+      break;
+    case SIGABRT:
+      ssig = "SIGABRT";
+      break;
+    default:
+      ssig = "UNKNOWN";
+      break;
+    }
+  sprintf (tmp,
+	   _
+	   ("ZOO Kernel failed to process your request, receiving signal %d = %s "),
+	   sig, ssig);
+  map* tmpMap=createMap("decode","suze");
+  maps* tmpMaps=createMaps("lenv");
+  setMapInMaps(tmpMaps,"lenv","message",tmp);
+  setMapInMaps(tmpMaps,"lenv","status","failed");
+  printExceptionReportResponseJ(tmpMaps,tmpMap);
+  //errorException (NULL, tmp, "InternalError", NULL);
+#ifdef DEBUG
+  fprintf (stderr, "Not this time!\n");
+#endif
+  exit (0);
+}
+  
+#endif
 
 /**
@@ -509,5 +1166,5 @@
 #ifdef WIN32
       HINSTANCE so =
-        LoadLibraryEx (tmps1, NULL, LOAD_WITH_ALTERED_SEARCH_PATH);						
+        LoadLibraryEx (tmps1, NULL, LOAD_WITH_ALTERED_SEARCH_PATH);
 #else
       void *so = dlopen (tmps1, RTLD_LAZY);
@@ -974,5 +1631,5 @@
 runRequest (map ** inputs)
 {
-	
+ 
 #ifndef USE_GDB
 #ifndef WIN32
@@ -990,6 +1647,4 @@
   map *r_inputs = NULL;
   map *request_inputs = *inputs;
-  //fprintf(stderr,"%s \n",json_object_to_json_string_ext(mapToJson(request_inputs),JSON_C_TO_STRING_PLAIN));
-  
 #ifdef IGNORE_METAPATH
   addToMap(request_inputs, "metapath", "");
@@ -1021,12 +1676,4 @@
   char conf_file[10240];
   snprintf (conf_file, 10240, "%s/%s/main.cfg", ntmp, r_inputs->value);
-#ifdef ETC_DIR
-#ifndef WIN32
-  getcwd (ntmp, 1024);
-#else
-  _getcwd (ntmp, 1024);
-#endif
-#endif
-
   if (conf_read (conf_file, m) == 2)
     {
@@ -1064,4 +1711,7 @@
     fstde = freopen (fstdem->value, "a+", stderr);
 
+  /**
+   * Language gesture
+   */
   r_inputs = getMap (request_inputs, "language");
   if (r_inputs == NULL)
@@ -1160,5 +1810,8 @@
       fprintf(stderr,"*** %s ***\n",tmpUrl);
 #endif
-      setMapInMaps(m,"main","serverAddress",tmpUrl);
+      if(getMapFromMaps(m,"main","proxied")==NULL)
+	setMapInMaps(m,"main","serverAddress",tmpUrl);
+      else
+	setMapInMaps(m,"lenv","serverAddress",tmpUrl);
     }
 
